"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getContext;

var _jss = require("jss");

var _styles = require("@material-ui/core/styles");

function createContext(themeObj) {
  return {
    theme: (0, _styles.createMuiTheme)(themeObj),
    // eslint-disable-next-line no-undef
    sheetsManager: new Map(),
    // This is needed in order to inject the critical CSS.
    sheetsRegistry: new _jss.SheetsRegistry(),
    // The standard class name generator.
    generateClassName: (0, _styles.createGenerateClassName)()
  };
}

var pageContext;

function getContext(themeObj) {
  // Make sure to create a new store for every server-side request so that data
  // isn't shared between connections (which would be bad)
  if (!process.browser) {
    return createContext(themeObj);
  } // Reuse context on the client-side


  if (!pageContext) {
    pageContext = createContext(themeObj);
  }

  return pageContext;
}

module.exports = exports.default;